package com.nifty.homepage2.jyube.hanabi;

import android.graphics.Paint;
import android.graphics.Paint.Style;

public class Color {
	public static class Hsv {
		public float h, s, v;

		public Hsv(float h, float s, float v) {
			while (h < 0) h = h + 360;
			while (h >= 360) h = h - 360;
			
			if (s > 1.0f) s = 1.0f;
			if (v > 1.0f) v = 1.0f;
			if (s < 0.0f) s = 0.0f;
			if (v < 0.0f) v = 0.0f;

			this.h = h;
			this.s = s;
			this.v = v;
		}

		public Paint toColor() {
			Paint color = new Paint();

			if (s == 0) {
				int rgb;
				rgb = (int)(v * 255);
				color.setARGB(255, rgb, rgb, rgb);

			} else {
				int r, g, b;
				int i = (int)(h / 60);
				double f = h - i;
				int m = (int)(v * (1 - s) * 255);
				int n = (int)(v * (1 - s * f) * 255);
				int k = (int)(v * (1 - s * (1 - f)) * 255);
				int v1 = (int)(v * 255);

				switch (i) {
				default:
				case 0:
					r = v1; g = k; b = m;
					break;
				case 1:
					r = n; g = v1; b = m;
					break;
				case 2:
					r = m; g = v1; b = k;
					break;
				case 3:
					r = m; g = n; b = v1;
					break;
				case 4:
					r = k; g = m; b = v1;
					break;
				case 5:
					r = v1; g = m; b = n;
					break;
				}
				color.setARGB(255, r, g, b);
			}
			color.setStyle(Style.FILL);

			return color;
		}
	}
}