package com.nifty.homepage2.jyube.hanabi;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Paint.Style;

public class FireBall {
	private float x, y, radius;
	private float dx, dy, decay;
	private Paint color;
	
	public FireBall() {
		x = 0;
		y = 0;
		radius = 1;
		dx = 0;
		dy = 0;
		decay = 0;
		color = new Paint();
	}
	
	public void setPosition(float x, float y) {
		this.x = x;
		this.y = y;
	}
	
	public void setRadius(float radius) {
		this.radius = radius;
	}
	
	public void setVecter(float unit, float angle) {
		double rad = angle * Math.PI / 180.0;
		dx = (float)(Math.cos(rad) * unit);
		dy = (float)(Math.sin(rad) * unit);
	}
	
	public void addVecter(float dx, float dy) {
		this.dx += dx;
		this.dy += dy;
	}

	public float getDecay() {
		return decay;
	}

	public void setDecay(float decay) {
		this.decay = decay;
	}

	public void setColor(int a, int r, int g, int b) {
		Paint color = new Paint();
		color.setARGB(a, r, g, b);
		color.setStyle(Style.FILL);
		this.color = color;
	}
	
	public void setColor(Paint color) {
		this.color = color;
	}
	
	public void update() {
		x += dx;
		y += dy;

		float rate = 1 - decay;
		dx *= rate;
		dy *= rate;
		radius *= rate;
	}
	
	public void draw(Canvas canvas) {
		canvas.drawCircle(x, y, radius, color);
	}

	public boolean isLost() {
		return (Math.abs(dx) <= 0.01 && Math.abs(dy) <= 0.01 || radius <= 0.01);
	}
}
