package com.nifty.homepage2.jyube.hanabi;

import android.graphics.Canvas;

public final class Screen {
	public static final int WIDTH = 1366;
	public static final int HEIGHT = 768;
	public static final int BALL_MAX = 360;
	
	public final static class Info {
		private float scale;
		private float offsetX;
		private float offsetY;
		
		public Info(float scale, float offsetX, float offsetY) {
			this.scale = scale;
			this.offsetX = offsetX;
			this.offsetY = offsetY;
		}

		public float getScale() {
			return scale;
		}

		public float getOffsetX() {
			return offsetX;
		}

		public float getOffsetY() {
			return offsetY;
		}
	}
	
	private static Info info = null;
	
	public static Info getInfo(Canvas canvas) {
		int w = canvas.getWidth();
		int h = canvas.getHeight();
		float scale = (w >= h)?
				(float)h / HEIGHT:
					(float)w / WIDTH;
		float dx = (w - WIDTH * scale) / 2;
		float dy = (h - HEIGHT * scale) / 2;

		Screen.info = new Info(scale, dx, dy);

		return info;
	}
	
	public static Info getInfo() {
		return info;
	}
	
	public final static class Position {
		private float x;
		private float y;
		
		public Position(float x, float y) {
			this.x = x;
			this.y = y;
		}

		public float getX() {
			return x;
		}

		public float getY() {
			return y;
		}
	}

	public static Position getScreenPosition(float x, float y) {
		if (info != null) {
			return new Position(
					(x - info.offsetX) / info.scale,
					(y - info.offsetY) / info.scale);
		}
		return null;
	}
	
	public static boolean in(float x, float y) {
		return (0.0 <= x && x < WIDTH
				&& 0.0 <= y && y < HEIGHT);
	}
}
